Subject: Re: PROBLEM: Power9: kernel oops on memory hotunplug from ppc64le guest

From: Bharata B Rao <[email-masked]>
Date: Mon, 20 May 2019 13:50:35 +0530

On Mon, May 20, 2019 at 05:00:21PM +1000, Nicholas Piggin wrote:
> Bharata B Rao's on May 20, 2019 3:56 pm:
> > On Mon, May 20, 2019 at 02:48:35PM +1000, Nicholas Piggin wrote:
> >> >> > git bisect points to
> >> >> >
> >> >> > commit 4231aba000f5a4583dd9f67057aadb68c3eca99d
> >> >> > Author: Nicholas Piggin <[email-masked]>
> >> >> > Date:   Fri Jul 27 21:48:17 2018 +1000
> >> >> >
> >> >> >     powerpc/64s: Fix page table fragment refcount race vs speculative references
> >> >> >
> >> >> >     The page table fragment allocator uses the main page refcount racily
> >> >> >     with respect to speculative references. A customer observed a BUG due
> >> >> >     to page table page refcount underflow in the fragment allocator. This
> >> >> >     can be caused by the fragment allocator set_page_count stomping on a
> >> >> >     speculative reference, and then the speculative failure handler
> >> >> >     decrements the new reference, and the underflow eventually pops when
> >> >> >     the page tables are freed.
> >> >> >
> >> >> >     Fix this by using a dedicated field in the struct page for the page
> >> >> >     table fragment allocator.
> >> >> >
> >> >> >     Fixes: 5c1f6ee9a31c ("powerpc: Reduce PTE table memory wastage")
> >> >> >     Cc: [email-masked] # v3.10+
> >> >> 
> >> >> That's the commit that added the BUG_ON(), so prior to that you won't
> >> >> see the crash.
> >> > 
> >> > Right, but the commit says it fixes page table page refcount underflow by
> >> > introducing a new field &page->pt_frag_refcount. Now we are hitting the underflow
> >> > for this pt_frag_refcount.
> >> 
> >> The fixed underflow is caused by a bug (race on page count) that got 
> >> fixed by that patch. You are hitting a different underflow here. It's
> >> not certain my patch caused it, I'm just trying to reproduce now.
> > 
> > Ok.
> 
> Can't reproduce I'm afraid, tried adding and removing 8GB memory from a
> 4GB guest (via host adding / removing memory device), and it just works.

Boot, add 8G, reboot, remove 8G is the sequence to reproduce.

> 
> It's likely to be an edge case like an off by one or rounding error
> that just happens to trigger in your config. Might be easiest if you
> could test with a debug patch.

Sure, I will continue debugging.

Regards,
Bharata.